// **********************************************************************
// RfLedRestrictor : PHSڑ̂ݓdgLEDLɂ
//
// Kazuaki Tauchi <kazuaki@tauchi.net>
// ----------------------------------------------------------------------
// 2007/11/08   VK쐬 v0.1ƂČJ
// 2007/11/08   (mod by tnj) GetPhsConnection() ̃oOCC풓
// ----------------------------------------------------------------------

#include <windows.h>
#include <aygshell.h>
#pragma comment(lib, "aygshell.lib")
#include <regext.h>

// State & Notification Broker APIs ֌W̒萔
#include <snapi.h>

// **********************************************************************
// 萔
//

#define REMOVE_EVENT                _T("RfLedRestrictorRemoveEvent")

#define LED_REG_KEY                 _T("ControlPanel\\Utility")               // HKCU
#define LED_REG_VALUE               _T("RFIndicator")                         // 0: 1:_
#define LED_EVENT_NAME              _T("RFindicator")

// ̕ӂ snapi.h Œ`ς݂ł
// ꂼ SN_CONNECTIONSMODEMCOUNT_PATH, SN_CONNECTIONSMODEMCOUNT_VALUE
//#define PHS_REG_KEY                 _T("System\\State\\Connections\\Modem")   // HKLM
//#define PHS_REG_VALUE               _T("Count")                               // ؒf0

#define APP_NAME					_T("RfLedRestrictor")
#define EVENT_APP_NAME				APP_NAME				// add, RegisterEventAppp

// **********************************************************************
// O[oϐ
//

HREGNOTIFY          g_hRegNotify;


// **********************************************************************
// vg^Cv錾
// 
static DWORD GetRFIndicator();
static VOID SetRFIndicator(DWORD);
static DWORD GetPhsConnection();
static HRESULT RegisterNotification();
static VOID RegNotifyCallbackFunc(HREGNOTIFY, DWORD, const PBYTE, const UINT);
static HRESULT UnregisterEventApp();	// add
static HRESULT RegisterEventApp();		// add


// **********************************************************************
// WinMain
//

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    HANDLE  hEvent          = NULL;
    DWORD   dwRFIndicator   ,
            dwPhsConnection ;
	

	// VXeo^̂̕ߐɎ擾
	dwPhsConnection = GetPhsConnection();

	// R}hCŏ𕪊 (蔲 :p / "RfLedRestrictor" ܂ނۂ)
	if ( NULL == _tcsstr(lpCmdLine, EVENT_APP_NAME) ) {
		// w肳ĂȂƂ͓o^E
		if ( FAILED( UnregisterEventApp() ) ) {
			// o^s
			if (SUCCEEDED(RegisterEventApp())) {
				// o^
				MessageBox(NULL,
					_T("VXe֓o^܂D_CAbvڑɎIɋN܂D"),
					APP_NAME,
					MB_OK | MB_ICONINFORMATION);
				// ݐڑĂȂ炱̂܂܏I
				if (0 == dwPhsConnection) return TRUE;
			} else {
				// o^s(??)
		        MessageBox(NULL,
					_T("VXeւ̓o^Ɏs܂D"),
					APP_NAME,
					MB_OK | MB_ICONERROR);
				return TRUE;
			}
		} else {
			// 
			MessageBox(NULL,
				_T("VXeւ̓o^܂D"),
				APP_NAME,
				MB_OK | MB_ICONINFORMATION);
				return TRUE;
		}
	} 
	
	// ʏ̏풓.

    hEvent = CreateEvent(NULL, FALSE, FALSE, REMOVE_EVENT);
    if (hEvent) {
        if (ERROR_ALREADY_EXISTS == GetLastError()) {
			// ɗ̂́C
			// ɋNɃVXeւ̓o^ꍇ
			// Ȃ̂ŉȂŏID
            // MessageBox(NULL, _T("풓܂"), APP_NAME, MB_OK);
            // SetEvent(hEvent);
            // CloseHandle(hEvent);
            return TRUE;
        }
    } else {
        return FALSE;
    }
	
    // l擾
    dwRFIndicator   = GetRFIndicator();

    if (0 == dwPhsConnection) {
        SetRFIndicator(0);
    } else {
        SetRFIndicator(1);  // 1ȊOԂĂ̂H
    }

    // ĎJn
    if (S_OK == RegisterNotification()) {
        WaitForSingleObject(hEvent, INFINITE);
    } else {
        MessageBox(NULL, _T("풓s"), APP_NAME, MB_OK);
    }

    // I
    RegistryCloseNotification(g_hRegNotify);
    SetRFIndicator(dwRFIndicator);
    CloseHandle(hEvent);
    return TRUE;
}


// **********************************************************************
// WXg֘A
//

// dgLED̐ݒ擾
static DWORD GetRFIndicator() 
{
    LONG    lResult;
    HKEY    hKey;
    DWORD   dwData,
            dwType,
            dwSize;

    dwData = 0;
    lResult = RegOpenKeyEx(HKEY_CURRENT_USER, LED_REG_KEY, 0, KEY_READ, &hKey);
    if (lResult == ERROR_SUCCESS) {
        dwSize = sizeof(dwData);
        lResult = RegQueryValueEx(hKey, LED_REG_VALUE, NULL, &dwType, (LPBYTE)&dwData , &dwSize);
	}
    RegCloseKey(hKey);
    hKey = NULL;

    return dwData;
}

// dgLED̐ݒύX
static VOID SetRFIndicator(DWORD dwData)
{
    LONG    lResult;
    HKEY    hKey;
    HANDLE  hEvent          = NULL;
    
    lResult = RegOpenKeyEx(HKEY_CURRENT_USER, LED_REG_KEY, 0, KEY_WRITE, &hKey);
    if (ERROR_SUCCESS == lResult) {
        lResult = RegSetValueEx(hKey, LED_REG_VALUE, NULL, REG_DWORD, (LPBYTE)&dwData, sizeof(DWORD));
	}
    RegCloseKey(hKey);
    hKey = NULL;

    // ύXʒmĂ݂
    hEvent = CreateEvent(NULL, 0, 0, LED_EVENT_NAME);
    if (hEvent) {
        SetEvent(hEvent);
        CloseHandle(hEvent);
        hEvent = NULL;
    }

}

// PHS̐ڑԂ擾
// snapi.h Œ`ꂽ萔gp悤ɕύXĂ܂
static DWORD GetPhsConnection()
{
    LONG    lResult;
    HKEY    hKey;
    DWORD   dwData,
            dwType,
            dwSize;

    dwData = 0;
	lResult = RegOpenKeyEx(SN_CONNECTIONSMODEMCOUNT_ROOT, 
		SN_CONNECTIONSMODEMCOUNT_PATH, 0, KEY_READ, &hKey);
	if (lResult == ERROR_SUCCESS) {
        dwSize = sizeof(dwData);
		lResult = RegQueryValueEx(hKey, SN_CONNECTIONSMODEMCOUNT_VALUE, NULL, &dwType, (LPBYTE)&dwData , &dwSize);
	}
    RegCloseKey(hKey);
    hKey = NULL;

    return dwData;
}

// PHS̐ڑԂ̃WXgĎ
// snapi.h Œ`ꂽ萔gp悤ɕύXĂ܂
static HRESULT RegisterNotification()
{
    return RegistryNotifyCallback(
        SN_CONNECTIONSMODEMCOUNT_ROOT,
		SN_CONNECTIONSMODEMCOUNT_PATH,
		SN_CONNECTIONSMODEMCOUNT_VALUE,
        RegNotifyCallbackFunc   ,
        0                       ,
        NULL                    ,
        &g_hRegNotify
    );
}

// PHSڑԂɂȂƂɓdgLED̐ݒύX
static VOID RegNotifyCallbackFunc(HREGNOTIFY hNotify, DWORD dwUserData, const PBYTE pData, const UINT cbData)
{
    DWORD   dwPhsConnection;
    dwPhsConnection = (*(DWORD *)pData);

    //SetRFIndicator(dwPhsConnection);
    if (0 == dwPhsConnection) {
        SetRFIndicator(0);
		
		// ̂܂܏I邽߃CxgN
		HANDLE hEvent = CreateEvent(NULL, FALSE, FALSE, REMOVE_EVENT);
		if (hEvent) {
			if (ERROR_ALREADY_EXISTS == GetLastError()) {
				SetEvent(hEvent);
				CloseHandle(hEvent);
			}
		}
	} else {
		// 炭ɗ邱Ƃ͂Ȃ
        SetRFIndicator(1);
    }
}

// VXeo^ĂCxg폜
static HRESULT UnregisterEventApp()
{
	return RegistryStopNotification(EVENT_APP_NAME);
}

// ڑԂωɎgN悤VXeɓo^
static HRESULT RegisterEventApp()
{
	HRESULT	hr;
	NOTIFICATIONCONDITION nc;
	
	TCHAR	szExePath[MAX_PATH];
	TCHAR	szThisPath[MAX_PATH];
	
	// ̃Gg폜	(Ԃl͖)
	UnregisterEventApp();
	
	// g̃pX擾
	GetModuleFileName(NULL, szThisPath, MAX_PATH);
	
	// pX quote 
	if( FAILED(StringCchCopy(szExePath, MAX_PATH, L"\"")) ||
		FAILED(StringCchCat(szExePath, MAX_PATH, szThisPath)) ||
		FAILED(StringCchCat(szExePath, MAX_PATH, L"\"")) ) {
			return S_FALSE;
	}
	
	// _CAAbvĎ
	nc.ctComparisonType	 = REG_CT_GREATER_OR_EQUAL;
	nc.dwMask			 = MAXDWORD;
	nc.TargetValue.dw	 = 1;

	// VXe֓o^
	hr = RegistryNotifyApp(
        SN_CONNECTIONSMODEMCOUNT_ROOT,
		SN_CONNECTIONSMODEMCOUNT_PATH,
		SN_CONNECTIONSMODEMCOUNT_VALUE,
		EVENT_APP_NAME,
		szExePath,
		NULL,
		NULL,
		0,
		0,
		&nc
		);
	
	return hr;
}
